uniform sampler2D texture0; 
uniform sampler2D texture1;
uniform float baseIntensity;
uniform float bloomIntensity;
varying vec2 texCoord;
 
const vec4 lumcoeff = vec4(0.299,0.587,0.114,0.);

void main(void)
{
	vec4 bloom = texture2D(texture0, texCoord);
	vec4 original = texture2D(texture1, texCoord);

	float l1 = baseIntensity;
	float l2 = dot(bloom, lumcoeff) * bloomIntensity;

	gl_FragColor = bloom * l2 + original * l1;
}