uniform sampler2D texture0; 
uniform vec2 motionVector;
uniform float speed;
uniform int kernelSize;

varying vec2 texCoord;
 
void main(void)
{
	vec4 color = vec4(0, 0, 0, 0);
	vec2 uv = texCoord;
	float sum = 0;
	float ratio = 1;
	
	for (int i=0; i<=kernelSize; i++) 
	{
		vec4 value = texture2D(texture0, uv);
		color += value * ratio;
		sum += ratio;
		
		uv -= motionVector * speed;
		
		if (uv.x<0 || uv.y<0 || uv.x>1 || uv.y>1) break;
		
		ratio /= 2;
	}
	
	color /= sum;
	
	gl_FragColor = color;
}