uniform sampler2D texture0; 
uniform float gamma;
uniform float bright;
varying vec2 texCoord;
 
void main(void)
{
	vec4 color = texture2D(texture0, texCoord);
	
	color = color * (bright + 0.0) + 0.03;
	color = color+0.029;
 
	float dbr = -color.r + 1.4;
	float dbg = -color.g + 1.4;
	float dbb = -color.b + 1.4;
	
	float pr = mix(dbr, 0.65, 0.5);
	float pg = mix(dbg, 0.65, 0.5);
	float pb = mix(dbb, 0.65, 0.5);
	
	color.r = pow((color.r * 0.95 - 0.002), pr);
	color.g = pow((color.g * 0.95 - 0.002), pg);
	color.b = pow((color.b * 0.99 + 0.000), pb);
	
	float rgb = max(color.r, max(color.g, color.b))/2+min(color.r, min(color.g, color.b))/2;
	float bw = pow(rgb, 0.7);
	float rgbr = mix(rgb, color.r, 0.7);
	float rgbg = mix(rgb, color.g, 0.7);
	float rgbb = mix(rgb, color.b, 0.7);
	float mixfactorr = max(0, (rgbr*2-1));
	float mixfactorg = max(0, (rgbg*2-1));
	float mixfactorb = max(0, (rgbb*2-1));
	float mixr = mix(color.r, bw, mixfactorr);
	float mixg = mix(color.g, bw, mixfactorg);
	float mixb = mix(color.b, bw, mixfactorb);
	color.r = clamp((mix(mixr, color.r, 0)), 0, 1);
	color.g = clamp((mix(mixg, color.g, 0)), 0, 1);
	color.b = clamp((mix(mixb, color.b, 0)), 0, 1);
	color.b = color.b*0.8+((color.r+color.g)/2)*0.2;
	color = max(((color*1.1)-0.06), 0);
	color.r = pow(color.r, gamma);
	color.g = pow(color.g, gamma);
	color.b = pow(color.b, gamma);
	color = color*1.03-0.03;
	
	gl_FragColor = color;
}