uniform sampler2D texture0; 
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform vec2 camerarange;
uniform float focalDepth;
uniform float range;
uniform float strength;
varying vec2 texCoord;

float readDepth( in vec2 coord ) {
  float n = camerarange.x;
  float f = camerarange.y;
  float z = texture2D(texture0, coord).x;
  return (2.0 * n) / (f + n - z * (f - n));
}

void main(void)
{
	float d = readDepth(texCoord);
	float min = focalDepth-range;
	if (min<0) min=0;
	float max = focalDepth+range;
	if (max>1) max=1;
	float bi = 0;
	
	if (d < min)
		bi = 1;
	else if (d > max)
		bi = 1;
	else 
		bi = abs(d-focalDepth)/range;
		
	bi *= strength;
	
	gl_FragColor = texture2D(texture1, texCoord) * (1-bi) + texture2D(texture2, texCoord) * bi;
}