uniform sampler2D texture0;
uniform float blurSize;

varying vec2 vTexCoord;
 
const float weightSum = 70.0 + 2.0 * (1.0 + 8.0 + 28.0 + 56.0);
 
void main(void)
{
   vec4 sum = vec4(0.0);
 
   sum += texture2D(texture0, vec2(vTexCoord.x - 4.0*blurSize, vTexCoord.y)) * 1.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x - 3.0*blurSize, vTexCoord.y)) * 8.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x - 2.0*blurSize, vTexCoord.y)) * 28.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x - blurSize, vTexCoord.y)) * 56.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x, vTexCoord.y)) * 70.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x + blurSize, vTexCoord.y)) * 56.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x + 2.0*blurSize, vTexCoord.y)) * 28.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x + 3.0*blurSize, vTexCoord.y)) * 8.0 / weightSum;
   sum += texture2D(texture0, vec2(vTexCoord.x + 4.0*blurSize, vTexCoord.y)) * 1.0 / weightSum;
 
   gl_FragColor = sum;
}