uniform sampler2D texture0; 
uniform sampler2D texture1; 
uniform float thickness;
uniform float threshold;
uniform vec2 camerarange;
varying vec2 texCoord;
 
float readDepth(vec2 coord) {
  float n = camerarange.x;
  float f = camerarange.y;
  float z = texture2D(texture1, coord).x;
  return (2.0 * n) / (f + n - z * (f - n)) * 1000;
}

float getFactor(vec2 coord) {
  float d = readDepth(coord);
  vec3 n = normalize(vec3(readDepth(coord+vec2(thickness,0))-d, readDepth(coord+vec2(0, thickness))-d, threshold));
  return n.z;
}
 
void main(void)
{
	vec4 color = texture2D(texture0, texCoord);
	color.rgb *= getFactor(texCoord);
	gl_FragColor = color;
}